<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: marketdata.proto

namespace Tinkoff\Invest\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 *Пакет биржевой информации по подписке.
 *
 * Generated from protobuf message <code>tinkoff.public.invest.api.contract.v1.MarketDataResponse</code>
 */
class MarketDataResponse extends \Google\Protobuf\Internal\Message
{
    protected $payload;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Tinkoff\Invest\V1\SubscribeCandlesResponse $subscribe_candles_response
     *          Результат подписки на свечи.
     *     @type \Tinkoff\Invest\V1\SubscribeOrderBookResponse $subscribe_order_book_response
     *          Результат подписки на стаканы.
     *     @type \Tinkoff\Invest\V1\SubscribeTradesResponse $subscribe_trades_response
     *          Результат подписки на поток обезличенных сделок.
     *     @type \Tinkoff\Invest\V1\SubscribeInfoResponse $subscribe_info_response
     *          Результат подписки на торговые статусы инструментов.
     *     @type \Tinkoff\Invest\V1\Candle $candle
     *          Свеча.
     *     @type \Tinkoff\Invest\V1\Trade $trade
     *          Сделки.
     *     @type \Tinkoff\Invest\V1\OrderBook $orderbook
     *          Стакан.
     *     @type \Tinkoff\Invest\V1\TradingStatus $trading_status
     *          Торговый статус.
     *     @type \Tinkoff\Invest\V1\Ping $ping
     *          Проверка активности стрима.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Marketdata::initOnce();
        parent::__construct($data);
    }

    /**
     *Результат подписки на свечи.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeCandlesResponse subscribe_candles_response = 1;</code>
     * @return \Tinkoff\Invest\V1\SubscribeCandlesResponse
     */
    public function getSubscribeCandlesResponse()
    {
        return $this->readOneof(1);
    }

    /**
     *Результат подписки на свечи.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeCandlesResponse subscribe_candles_response = 1;</code>
     * @param \Tinkoff\Invest\V1\SubscribeCandlesResponse $var
     * @return $this
     */
    public function setSubscribeCandlesResponse($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\SubscribeCandlesResponse::class);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     *Результат подписки на стаканы.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeOrderBookResponse subscribe_order_book_response = 2;</code>
     * @return \Tinkoff\Invest\V1\SubscribeOrderBookResponse
     */
    public function getSubscribeOrderBookResponse()
    {
        return $this->readOneof(2);
    }

    /**
     *Результат подписки на стаканы.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeOrderBookResponse subscribe_order_book_response = 2;</code>
     * @param \Tinkoff\Invest\V1\SubscribeOrderBookResponse $var
     * @return $this
     */
    public function setSubscribeOrderBookResponse($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\SubscribeOrderBookResponse::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     *Результат подписки на поток обезличенных сделок.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeTradesResponse subscribe_trades_response = 3;</code>
     * @return \Tinkoff\Invest\V1\SubscribeTradesResponse
     */
    public function getSubscribeTradesResponse()
    {
        return $this->readOneof(3);
    }

    /**
     *Результат подписки на поток обезличенных сделок.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeTradesResponse subscribe_trades_response = 3;</code>
     * @param \Tinkoff\Invest\V1\SubscribeTradesResponse $var
     * @return $this
     */
    public function setSubscribeTradesResponse($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\SubscribeTradesResponse::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     *Результат подписки на торговые статусы инструментов.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeInfoResponse subscribe_info_response = 4;</code>
     * @return \Tinkoff\Invest\V1\SubscribeInfoResponse
     */
    public function getSubscribeInfoResponse()
    {
        return $this->readOneof(4);
    }

    /**
     *Результат подписки на торговые статусы инструментов.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.SubscribeInfoResponse subscribe_info_response = 4;</code>
     * @param \Tinkoff\Invest\V1\SubscribeInfoResponse $var
     * @return $this
     */
    public function setSubscribeInfoResponse($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\SubscribeInfoResponse::class);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     *Свеча.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Candle candle = 5;</code>
     * @return \Tinkoff\Invest\V1\Candle
     */
    public function getCandle()
    {
        return $this->readOneof(5);
    }

    /**
     *Свеча.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Candle candle = 5;</code>
     * @param \Tinkoff\Invest\V1\Candle $var
     * @return $this
     */
    public function setCandle($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\Candle::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     *Сделки.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Trade trade = 6;</code>
     * @return \Tinkoff\Invest\V1\Trade
     */
    public function getTrade()
    {
        return $this->readOneof(6);
    }

    /**
     *Сделки.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Trade trade = 6;</code>
     * @param \Tinkoff\Invest\V1\Trade $var
     * @return $this
     */
    public function setTrade($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\Trade::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     *Стакан.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.OrderBook orderbook = 7;</code>
     * @return \Tinkoff\Invest\V1\OrderBook
     */
    public function getOrderbook()
    {
        return $this->readOneof(7);
    }

    /**
     *Стакан.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.OrderBook orderbook = 7;</code>
     * @param \Tinkoff\Invest\V1\OrderBook $var
     * @return $this
     */
    public function setOrderbook($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\OrderBook::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     *Торговый статус.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.TradingStatus trading_status = 8;</code>
     * @return \Tinkoff\Invest\V1\TradingStatus
     */
    public function getTradingStatus()
    {
        return $this->readOneof(8);
    }

    /**
     *Торговый статус.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.TradingStatus trading_status = 8;</code>
     * @param \Tinkoff\Invest\V1\TradingStatus $var
     * @return $this
     */
    public function setTradingStatus($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\TradingStatus::class);
        $this->writeOneof(8, $var);

        return $this;
    }

    /**
     *Проверка активности стрима.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Ping ping = 9;</code>
     * @return \Tinkoff\Invest\V1\Ping
     */
    public function getPing()
    {
        return $this->readOneof(9);
    }

    /**
     *Проверка активности стрима.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Ping ping = 9;</code>
     * @param \Tinkoff\Invest\V1\Ping $var
     * @return $this
     */
    public function setPing($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\Ping::class);
        $this->writeOneof(9, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getPayload()
    {
        return $this->whichOneof("payload");
    }

}

